"""
DllToLib&Inc v1.1
(c) Mantissa для wasm.in
"""

import os
import sys
import subprocess
import re

"""
Используется регулярное выражение для поиска имен функций.
Проверить корректность выражения можно на сайте https://regex101.com/
"""


def parse_funName(input_text):
    lines = input_text.split("\n")
    exports = []
    for line in lines:
        match = re.search(r'^\s*\d+\s+[0-9a-fA-F]+\s+(?:[0-9a-fA-F]+\s+)?(.+?)(?=\s+\(forwarded|\s*$)', line)
        if match:
            if not match.group(1).startswith('['):
                exports.append(match.group(1))
    return exports


def main():
    os.chdir(directory)
    count = 0
    for file in os.listdir(directory):
        os.chdir(directory)
        if file.endswith(".dll"):
            def_file = _libdir + file[:-4] + ".def"
            inc_file = _incdir + file[:-4] + ".inc"
            #print(inc_file)
            subprocess.run(f"dumpbin /nologo /exports {file} > {def_file}", shell=True)
            with open(def_file, "r") as f:
                exports = parse_funName(f.read())
            with open(def_file, "w") as f:
                f.write("EXPORTS\n")
                for export in exports:
                    f.write(export + "\n")
            lib_file = _libdir + file[:-4] + ".lib"
            subprocess.run(f"lib /nologo /def:{def_file} /out:{lib_file} > nul", shell=True)
            with open(inc_file, "w") as f:
                for export in exports:
                    f.write("extern __imp_" + export + ":qword \n" + export + " TEXTEQU <__imp_" + export + ">\n")
            os.chdir(_libdir)
            os.remove(def_file)
            count += 1
            if count % 100 == 0:
                print(f"Прогресс {count} из {len(os.listdir(directory))}\n")

    print("Завершено.")


def remove_lines_starting_with_bracket(file_path):
    with open(file_path, 'r') as file:
        lines = file.readlines()

    with open(file_path, 'w') as file:
        for line in lines:
            if not line.startswith('['):
                file.write(line)


if __name__ == "__main__":
    if len(sys.argv) < 3:
        print("Укажите верно параметры:\n"
              "1 - путь до Dll \n"
              "2 - путь для сохранения .lib\n"
              "3 - путь для сохранения .inc\n")
        exit(-1)
    directory = sys.argv[1] + '\\'
    _libdir = sys.argv[2] + '\\'
    print(_libdir)
    _incdir = sys.argv[3] + '\\'
    print(_incdir)
    os.system('chcp 65001')
    try:
        pass
        main()
    except FileNotFoundError as E:
        print(E)
